package com.android.MusicShare;


import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.facebook.android.AsyncFacebookRunner;
import com.facebook.android.BaseDialogListener;
import com.facebook.android.BaseRequestListener;
import com.facebook.android.Facebook;
import com.facebook.android.FacebookError;
import com.facebook.android.LoginButton;
import com.facebook.android.SessionEvents;
import com.facebook.android.SessionStore;
import com.facebook.android.Util;
import com.facebook.android.SessionEvents.AuthListener;
import com.facebook.android.SessionEvents.LogoutListener;




public class FacebookActivity extends Activity {
    
    // Your Facebook Application ID must be set before running this example
    // See http://www.facebook.com/developers/createapp.php
    public static final String APP_ID = "152382614788685";
    public static String TAG = "FacebookActivity";
    private static final String[] PERMISSIONS =
        new String[] {"publish_stream", "read_stream", "offline_access","rsvp_event"};
    private LoginButton mLoginButton;
    private TextView mText;
    private Button mJoinButton;
    private Button mPostButton;
    private Button mDeleteButton;
    private Button mUpdateButton;    
    private Facebook mFacebook;
    private AsyncFacebookRunner mAsyncRunner;
    public static final String TOKEN = "access_token";
    public boolean isSessionValid() {
        return (mFacebook.getAccessToken() != null) && ((mFacebook.getAccessExpires() == 0) || 
            (System.currentTimeMillis() < mFacebook.getAccessExpires()));
    }
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if (APP_ID == null) {
            Util.showAlert(this, "Warning", "Facebook Applicaton ID must be " +
                    "specified before running this example: see FacebookActivity.java");
        }
        
        setContentView(R.layout.facebook);
        mLoginButton = (LoginButton) findViewById(R.id.login);
        mText = (TextView) FacebookActivity.this.findViewById(R.id.txt);
        mJoinButton = (Button) findViewById(R.id.joinButton);
        mPostButton = (Button) findViewById(R.id.postButton);
        mDeleteButton = (Button) findViewById(R.id.deletePostButton);
        mUpdateButton = (Button) findViewById(R.id.updateButton);
        
       	mFacebook = new Facebook();
       	mAsyncRunner = new AsyncFacebookRunner(mFacebook);
       
        SessionStore.restore(mFacebook, this);
        SessionEvents.addAuthListener(new SampleAuthListener());
        SessionEvents.addLogoutListener(new SampleLogoutListener());
        mLoginButton.init(mFacebook, PERMISSIONS);
        
        mJoinButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {    	
            	/*try {
            		Bundle parameters = new Bundle();
                	parameters.putString("method", "POST");
                	//parameters.putString("target_id", "100001540665683");
                	//parameters.putString("status", "How are you");
                	String response = mFacebook.request("146154435419261/attending");
                	mText.setText(response);
					//mFacebook.request("146154435419261/attending");
				} catch (MalformedURLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}   */  
            	
            	Thread cThread = new Thread(new JoinGroup());            	 
                cThread.start();
            }
        });
        mJoinButton.setVisibility(mFacebook.isSessionValid() ?
                View.VISIBLE :
                View.INVISIBLE);
 
        mUpdateButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
            	Thread cThread = new Thread(new UpdateGroup());            	 
                cThread.start();
                
            }
        });
        mUpdateButton.setVisibility(mFacebook.isSessionValid() ?
                View.VISIBLE :
                View.INVISIBLE);
        
        mPostButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                mFacebook.dialog(FacebookActivity.this, "stream.publish", 
                        new SampleDialogListener());          
            }
        });
        mPostButton.setVisibility(mFacebook.isSessionValid() ?
                View.VISIBLE : 
                View.INVISIBLE);
    }
    private Handler facebookHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
        	String response = msg.obj+"";
        	//mText.setText(response);
        	Toast.makeText(FacebookActivity.this, response, 500).show();
        }
    };
    public class JoinGroup implements Runnable{
    	
    	public void run(){
    		
        	try {
        		Bundle b = new Bundle();
        		b.putString("method", "users.setStatus");
        		b.putString("status", getLocalIpAddress());   		
        		String response=mFacebook.request(b);       		
        		Message msg = Message.obtain();
        		msg.obj="IP "+getLocalIpAddress()+ " is published";
        		facebookHandler.sendMessage(msg);
        		
        		Bundle c = new Bundle();
        		c.putString("method", "events.rsvp");
        		c.putString("eid", "146154435419261"); 
        		c.putString("rsvp_status", "attending");
        		String response2=mFacebook.request(c);
        		Message msg2 = Message.obtain();
        		msg2.obj="Group Joined";
        		facebookHandler.sendMessage(msg2);
        		
        		
        		response=mFacebook.request("146154435419261/attending",new Bundle(),"GET");
        		
        		//JSONObject json = Util.parseJson(response);
        		//JSONArray data = json.getJSONArray("data");
                //for(int i=0;i<json.length();i++){
                	//JSONObject temp = data.getJSONObject(i);
                	//String name = temp.getString("name");	
                	//String id = temp.getString("id");
                	//Log.i(TAG,name+" "+id);
                //}
                String[] responseArray = response.split("\"");
                for(int i=1;i*8+2<responseArray.length;i++){
                	Log.i(TAG,"User id: "+responseArray[i*8+1]);
                	if(!responseArray[i*8+1].equals("100000224700757")){
                		Log.i(TAG,"me info: "+mFacebook.request("me",new Bundle(),"GET"));
                		if(!responseArray[i*8+1].equals(mFacebook.request("me",new Bundle(),"GET").split("\"")[3])){
                		String name = responseArray[i*8-3];
                		Log.i(TAG,name);
                		String id = responseArray[i*8+1];
                		Log.i(TAG,id);
                		b = new Bundle();
                		b.putString("method", "status.get");
                		b.putString("uid", id);
                		b.putString("limit", "1");
                		Log.i(TAG,id);
                		Log.i(TAG,mFacebook.request(b));
                		String status=mFacebook.request(b).split("\"")[3].substring(3);       		
                		Message msg3 = Message.obtain();
                		msg3.obj=name+" on "+status;
                		facebookHandler.sendMessage(msg3);
                		String[] userArrayTemp = new String[FriendsList.userArray.length+1];
    					String[] hostArrayTemp = new String[FriendsList.hostArray.length+1];
    					String[] infoArrayTemp = new String[FriendsList.infoArray.length+1];
    					for(int j=0;j<FriendsList.infoArray.length;j++){
    						userArrayTemp[j]=FriendsList.userArray[j];
    						hostArrayTemp[j]=FriendsList.hostArray[j];
    						infoArrayTemp[j]=FriendsList.infoArray[j];
    						if(userArrayTemp[j].equals(name))continue;
    					}
    					userArrayTemp[FriendsList.userArray.length] = name;
    					hostArrayTemp[FriendsList.hostArray.length] = status+"/"+"8888";
    					infoArrayTemp[FriendsList.infoArray.length] = name+" at "+status+" on port 8888";
    					FriendsList.userArray=userArrayTemp;
    					FriendsList.hostArray=hostArrayTemp;
    					FriendsList.infoArray=infoArrayTemp;
                		}
                	}
                }
        		
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				Log.e(TAG,e.toString());
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				Log.e(TAG,e.toString());
			} catch (IOException e) {
				// TODO Auto-generated catch block
				Log.e(TAG,e.toString());
			}
			
    	}
    }
    public class UpdateGroup implements Runnable{
    	
    	public void run(){
    		try {
        				
        		String response=mFacebook.request("146154435419261/attending",new Bundle(),"GET");
        		
        		//JSONObject json = Util.parseJson(response);
        		//JSONArray data = json.getJSONArray("data");
                //for(int i=0;i<json.length();i++){
                	//JSONObject temp = data.getJSONObject(i);
                	//String name = temp.getString("name");	
                	//String id = temp.getString("id");
                	//Log.i(TAG,name+" "+id);
                //}
                String[] responseArray = response.split("\"");
                for(int i=1;i*8+2<responseArray.length;i++){
                	if(!responseArray[i*8+1].equals("100000224700757")&&!responseArray[i*8+1].equals(mFacebook.request("me",new Bundle(),"GET").split("\"")[3])){
                		String name = responseArray[i*8-3];
                		Log.i(TAG,name);
                		String id = responseArray[i*8+1];
                		Log.i(TAG,id);
                		Bundle b = new Bundle();
                		b.putString("method", "status.get");
                		b.putString("uid", id);
                		b.putString("limit", "1");
                		String status=mFacebook.request(b).split("\"")[3].substring(3);       		
                		Message msg = Message.obtain();
                		msg.obj=name+" on "+status;
                		facebookHandler.sendMessage(msg);
                		String[] userArrayTemp = new String[FriendsList.userArray.length+1];
    					String[] hostArrayTemp = new String[FriendsList.hostArray.length+1];
    					String[] infoArrayTemp = new String[FriendsList.infoArray.length+1];
    					boolean existuser=false;
    					for(int j=0;j<FriendsList.infoArray.length;j++){
    						userArrayTemp[j]=FriendsList.userArray[j];
    						hostArrayTemp[j]=FriendsList.hostArray[j];
    						infoArrayTemp[j]=FriendsList.infoArray[j];
    						if(userArrayTemp[j].equals(name))existuser=true;
    					}
    					if(existuser)continue;
    					userArrayTemp[FriendsList.userArray.length] = name;
    					hostArrayTemp[FriendsList.hostArray.length] = status+"/"+"8888";
    					infoArrayTemp[FriendsList.infoArray.length] = name+" at "+status+" on port 8888";
    					FriendsList.userArray=userArrayTemp;
    					FriendsList.hostArray=hostArrayTemp;
    					FriendsList.infoArray=infoArrayTemp;
                	}
                }
                
                
        		Bundle b = new Bundle(); 
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				Log.e(TAG,e.toString());
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				Log.e(TAG,e.toString());
			} catch (Exception e) {
				// TODO Auto-generated catch block
				Log.e(TAG,e.toString());
			} 
    	}
    }
    private String getLocalIpAddress() {
        try {
            for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
                NetworkInterface intf = en.nextElement();
                for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
                    InetAddress inetAddress = enumIpAddr.nextElement();
                    if (!inetAddress.isLoopbackAddress()) { return inetAddress.getHostAddress().toString(); }
                }
            }
        } catch (SocketException ex) {
            Log.e("SocketException", ex.toString());
        }
        return null;
    }
    public class SampleAuthListener implements AuthListener {
        
        public void onAuthSucceed() {
            mText.setText("You have logged in! ");
            mJoinButton.setVisibility(View.VISIBLE);
            mUpdateButton.setVisibility(View.VISIBLE);
            mPostButton.setVisibility(View.VISIBLE);
        }

        public void onAuthFail(String error) {
            mText.setText("Login Failed: " + error);
        }
    }
    
    public class SampleLogoutListener implements LogoutListener {
        public void onLogoutBegin() {
            mText.setText("Logging out...");
        }
        
        public void onLogoutFinish() {
            mText.setText("You have logged out! ");
            mJoinButton.setVisibility(View.INVISIBLE);
            mUpdateButton.setVisibility(View.INVISIBLE);
            mPostButton.setVisibility(View.INVISIBLE);
        }
    }
    
    public class SampleRequestListener extends BaseRequestListener {

        public void onComplete(final String response) {
            try {
                // process the response here: executed in background thread
                Log.d("Facebook-Example", "Response: " + response.toString());
                JSONObject json = Util.parseJson(response);
                //final String name = json.getString("name");
                final String name = "Siqi";
                // then post the processed result back to the UI thread
                // if we do not do this, an runtime exception will be generated
                // e.g. "CalledFromWrongThreadException: Only the original 
                // thread that created a view hierarchy can touch its views."
                FacebookActivity.this.runOnUiThread(new Runnable() {
                    public void run() {
                        mText.setText("Hello there, " + name + "!");
                    }
                });
            } catch (JSONException e) {
                Log.w("Facebook-Example", "JSON Error in response");
            } catch (FacebookError e) {
                Log.w("Facebook-Example", "Facebook Error: " + e.getMessage());
            }
        }
    }
 
    public class SampleUploadListener extends BaseRequestListener {

        public void onComplete(final String response) {
            try {
                // process the response here: (executed in background thread)
                Log.d("Facebook-Example", "Response: " + response.toString());
                JSONObject json = Util.parseJson(response);
                final String src = json.getString("src");
                
                // then post the processed result back to the UI thread
                // if we do not do this, an runtime exception will be generated
                // e.g. "CalledFromWrongThreadException: Only the original 
                // thread that created a view hierarchy can touch its views."
                FacebookActivity.this.runOnUiThread(new Runnable() {
                    public void run() {
                        mText.setText("Hello there, photo has been uploaded at \n" + src);
                    }
                });
            } catch (JSONException e) {
                Log.w("Facebook-Example", "JSON Error in response");
            } catch (FacebookError e) {
                Log.w("Facebook-Example", "Facebook Error: " + e.getMessage());
            }
        }
    }
    public class WallPostRequestListener extends BaseRequestListener {
        
        public void onComplete(final String response) {
            Log.d("Facebook-Example", "Got response: " + response);
            String message = "<empty>";
            try {
                JSONObject json = Util.parseJson(response);
                message = json.getString("message");
            } catch (JSONException e) {
                Log.w("Facebook-Example", "JSON Error in response");
            } catch (FacebookError e) {
                Log.w("Facebook-Example", "Facebook Error: " + e.getMessage());
            }
            final String text = "Your Wall Post: " + message;
            FacebookActivity.this.runOnUiThread(new Runnable() {
                public void run() {
                    mText.setText(text);
                }
            });
        }
    }
    
    public class WallPostDeleteListener extends BaseRequestListener {
        
        public void onComplete(final String response) {
            if (response.equals("true")) {
                Log.d("Facebook-Example", "Successfully deleted wall post");
                FacebookActivity.this.runOnUiThread(new Runnable() {
                    public void run() {
                        mDeleteButton.setVisibility(View.INVISIBLE);
                        mText.setText("Deleted Wall Post");
                    }
                });
            } else {
                Log.d("Facebook-Example", "Could not delete wall post");
            }
        }
    }
    
    public class SampleDialogListener extends BaseDialogListener {

        public void onComplete(Bundle values) {
            final String postId = values.getString("post_id");
            if (postId != null) {
                Log.d("Facebook-Example", "Dialog Success! post_id=" + postId);
                mAsyncRunner.request(postId, new WallPostRequestListener());
                mDeleteButton.setOnClickListener(new OnClickListener() {
                    public void onClick(View v) {
                        mAsyncRunner.request(postId, new Bundle(), "DELETE", 
                                new WallPostDeleteListener());
                    }
                });
                mDeleteButton.setVisibility(View.VISIBLE);
            } else {
                Log.d("Facebook-Example", "No wall post made");
            }
        }
    }
    @Override
	 public void onDestroy(){
	 super.onDestroy();
	 
		try {
			Bundle c = new Bundle();
			c.putString("method", "events.rsvp");
			c.putString("eid", "146154435419261"); 
			c.putString("rsvp_status", "declined");
			mFacebook.request(c);
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
}