package com.android.MusicShare;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class FriendsList extends ListActivity{
	public static String[] userArray = null;
	public static String[] hostArray = null;
	public static String[] infoArray = null;
	public static final int NEW_FRIEND = 0;
	public static final int REFRESH = 1;
	public static final int OPTIONS = 2;
	public static final int INFO = 3;
	ListView lv = null;
	public void loadArray(){
		userArray = new String[1];
		hostArray = new String[1];
		infoArray = new String[1];
		userArray[0] = "Mike";
		hostArray[0] = "192.168.1.110/1234";
		infoArray[0] = "Mike at 192.168.1.110 on port 1234";
	}
	@Override
    public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		loadArray();
		
		lv = getListView(); 
		lv.setAdapter(new ArrayAdapter<String>(this, R.layout.list_item, infoArray));

		  
		  lv.setTextFilterEnabled(true);
		  lv.setOnItemClickListener(new OnItemClickListener() {
		    public void onItemClick(AdapterView<?> parent, View view,
		        int position, long id) {
		      // When clicked, show a toast with the TextView text
		      Toast.makeText(getApplicationContext(), ((TextView) view).getText(),
		          Toast.LENGTH_SHORT).show();
		    }
		  });
	}

	/* Creates the menu items */
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(0, NEW_FRIEND, 0, "New Friend").setIcon(R.drawable.ic_menu_add);
		menu.add(0, REFRESH, 0, "Refresh").setIcon(R.drawable.ic_menu_search);	    
	    menu.add(0, OPTIONS, 0, "Options").setIcon(R.drawable.ic_menu_preferences);
	    menu.add(0, INFO, 0, "Info").setIcon(R.drawable.ic_menu_info_details);	    
	    return true;
	    
	}

	/* Handles item selections */
	public boolean onOptionsItemSelected(MenuItem item) {
	    switch (item.getItemId()) {
	    case NEW_FRIEND:
	    	LayoutInflater inflater = (LayoutInflater)FriendsList.this.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			final View view = inflater.inflate(R.layout.dia_text, null);
			final TextView name = (TextView)view.findViewById(R.id.newuser);
			final TextView host = (TextView)view.findViewById(R.id.newhost);
			final TextView port = (TextView)view.findViewById(R.id.newport);
			new AlertDialog.Builder(FriendsList.this)
			.setView(view)
			.setPositiveButton("Add", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					String[] userArrayTemp = new String[userArray.length+1];
					String[] hostArrayTemp = new String[hostArray.length+1];
					String[] infoArrayTemp = new String[infoArray.length+1];
					for(int i=0;i<infoArray.length;i++){
						userArrayTemp[i]=userArray[i];
						hostArrayTemp[i]=hostArray[i];
						infoArrayTemp[i]=infoArray[i];
					}
					userArrayTemp[userArray.length] = name.getText().toString();
					hostArrayTemp[hostArray.length] = host.getText().toString()+"/"+port.getText().toString();
					infoArrayTemp[infoArray.length] = name.getText().toString()+" at "+host.getText().toString()+" on port "+port.getText().toString();
					userArray=userArrayTemp;
					hostArray=hostArrayTemp;
					infoArray=infoArrayTemp;
					lv.setAdapter(new ArrayAdapter<String>(FriendsList.this, R.layout.list_item, infoArray));

					
				}
			})
			.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			    public void onClick(DialogInterface dialog, int which) {
			    }
			}).create().show();


	    	
	        return true;
	    case REFRESH:
	    	lv.setAdapter(new ArrayAdapter<String>(FriendsList.this, R.layout.list_item, infoArray));
	        return true;	    
	    case OPTIONS:
	        //newGame();
	        return true;
	    case INFO:
	        //quit();
	        return true;
	    }
	    return false;
	}
	@Override
	public void onResume(){
		super.onResume();
		lv.setAdapter(new ArrayAdapter<String>(FriendsList.this, R.layout.list_item, infoArray));
	}
	
}
