package com.android.MusicShare;

import java.util.HashMap;

import android.app.ListActivity;
import android.content.ContentUris;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.provider.MediaStore.Audio.Media;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListAdapter;
import android.widget.SimpleCursorAdapter;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class MusicList extends ListActivity{
	private MediaPlayer mp;
	Cursor mCursor = null;
	public static String TAG = "MusicList";
	public static final int PLAY_ALL = 0;
	public static final int REFRESH = 1;
	public static final int OPTIONS = 2;
	public static final int INFO = 3;
	public static String[] songsName = null;
	public static String[] songsPath = null;
	public static HashMap<String,String> interestsMap=null;
	private String interestLog = "";
	public void loadSongs(){	
			int rows = mCursor.getCount();
		    if (mCursor.moveToFirst()) {
		    	songsName = new String[rows];
		    	songsPath = new String[rows];
		        String name; 
		        String path; 
		        int nameColumn = mCursor.getColumnIndex(Media.TITLE); 
		        int pathColumn = mCursor.getColumnIndex(Media.DISPLAY_NAME); 
		        int i = 0;
		        do {

		            name = mCursor.getString(nameColumn);
		            Log.i(TAG,name);
		            path = mCursor.getString(pathColumn);
		            Log.i(TAG,path);
		            songsName[i]=name;
		            songsPath[i]=path;
		            i++;
		        } while (mCursor.moveToNext());		        
		    }

	}
	public void loadInterests(){
		int rows = mCursor.getCount();
	    if (mCursor.moveToFirst()) {
	        String album; 
	        String artist; 
	        int albumColumn = mCursor.getColumnIndex(Media.ALBUM); 
	        int artistColumn = mCursor.getColumnIndex(Media.ARTIST);
	        HashMap<String,Integer> albumOccurenceMap=new HashMap<String,Integer>();
	        HashMap<String,Integer> artistOccurenceMap=new HashMap<String,Integer>();
	        do {

	            album = mCursor.getString(albumColumn);
	            if(albumOccurenceMap.containsKey(album)){
	            	 int score;
						score=(Integer)albumOccurenceMap.get(album);
						score+=1;
						albumOccurenceMap.put(album, score);
	            }
	            else{
	            	albumOccurenceMap.put(album, 1);
	            }
	            Log.i(TAG,album);
	            artist = mCursor.getString(artistColumn);
	            if(artistOccurenceMap.containsKey(artist)){
	            	int score;
					score=(Integer)artistOccurenceMap.get(artist);
					score+=1;
					artistOccurenceMap.put(artist, score);
	            }
	            else{
	            	artistOccurenceMap.put(artist, 1);
	            }
	            Log.i(TAG,artist);
	        } while (mCursor.moveToNext());
	        for(String temp:albumOccurenceMap.keySet()){
				if((Integer)albumOccurenceMap.get(temp)>2||(Integer)albumOccurenceMap.get(temp)*5>rows){
					interestsMap.put(temp, "album");
					interestLog+="Album interest: "+temp+", "+(Integer)albumOccurenceMap.get(temp)+" out of total "+rows+" songs.\n";
				}
			 }
	        for(String temp:artistOccurenceMap.keySet()){
	        	if((Integer)artistOccurenceMap.get(temp)>3||(Integer)artistOccurenceMap.get(temp)>rows*0.3){
	        		interestsMap.put(temp, "artist");
	        		interestLog+="Artist interest: "+temp+", "+(Integer)artistOccurenceMap.get(temp)+" out of total "+rows+" songs.\n";
	        	}
			 }
	    }
	    
	    //int pathCol = mCursor.getColumnIndex(Genres.NAME); 
	}
	
	/** Called when the activity is first created. */
	@Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
	 mCursor = this.getContentResolver().query(MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, null, null, null, null);
     startManagingCursor(mCursor);
     loadSongs();
     interestsMap=new HashMap<String, String>();
     loadInterests();
     // Now create a new list adapter bound to the cursor.
     // SimpleListAdapter is designed for binding to a Cursor.
     ListAdapter adapter = new SimpleCursorAdapter(
             this, // Context.
             android.R.layout.two_line_list_item,  // Specify the row template to use (here, two columns bound to the two retrieved cursor
             mCursor,                                              // Pass in the cursor to bind to.
             new String[] {Media.TITLE, Media.ARTIST},           // Array of cursor columns to bind to.
             new int[] {android.R.id.text1, android.R.id.text2});  // Parallel array of which template objects to bind to those columns.

     // Bind to our new adapter.
     setListAdapter(adapter);
		
		/*ContentResolver cr = getContentResolver();
		 Uri allaudio_uri = MediaStore.Audio.Media.EXTERNAL_CONTENT_URI;
		    Cursor ca= managedQuery(allaudio_uri, STAR, null,null,null);
		    for(ca.moveToFirst(); !ca.isAfterLast(); ca.moveToNext()){

		    		ca.getString(ca.getColumnIndex("title"));

		    }*/
		
		this.getListView().setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				
				Uri myMusic = ContentUris.withAppendedId(Media.EXTERNAL_CONTENT_URI, id);
				if(mp==null){
					mp=new MediaPlayer();
			    audioPlayer(MusicList.this,myMusic);
				}
			    /*Intent it = new Intent(MusicList.this, PlayMusic.class);
			    it.putExtra("uri", myMusic);
			    it.putExtra("songsName", songsName[position]);*/
				
			}
		});
	}
	public void audioPlayer(Context context,Uri uri){
	    mp= MediaPlayer.create(context, uri);
	    mp.start();
	}
	
	@Override
	protected void onPause() {
	    super.onPause();
	    if(mp!=null&&mp.isPlaying()){ //you need to check if it is playing first, or you might get a null pointer exception!
	        mp.stop();
	        
	    }
	}
	
	@Override
	 public void onDestroy(){
	 super.onDestroy();
	    if(mp!=null)mp.release();
	    if(mCursor!=null)mCursor.close();
	 }
	
	/* Creates the menu items */
	public boolean onCreateOptionsMenu(Menu menu) {
	    menu.add(0, PLAY_ALL, 0, "Play All").setIcon(R.drawable.ic_menu_gallery);
	    menu.add(0, REFRESH, 0, "REFRESH").setIcon(R.drawable.ic_menu_rotate);
	    menu.add(0, OPTIONS, 0, "Option").setIcon(R.drawable.ic_menu_preferences);
	    menu.add(0, INFO, 0, "Interest").setIcon(R.drawable.ic_menu_info_details);
	    return true;
	}

	/* Handles item selections */
	public boolean onOptionsItemSelected(MenuItem item) {
	    switch (item.getItemId()) {
	    case PLAY_ALL:
	        //newGame();
	        return true;
	    case REFRESH:
	        startManagingCursor(mCursor);
	        return true;
	    case OPTIONS:
	        //newGame();
	        return true;
	    case INFO:
	    	Toast.makeText(getApplicationContext(), interestLog, Toast.LENGTH_LONG).show();
	        return true;
	    }
	    return false;
	}

}
